VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls9858EVBD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Public Enum adiBinValues
    abvLow = 0
    abvHigh = 1
End Enum
 
Public Enum evbdComMode
    Parallel = 0
    Serial = 1
End Enum

Public Enum evbdSerMode
    TwoWire = 0
    ThreeWire = 1
End Enum

'local variable(s) to hold property value(s)
Private mvarReset As adiBinValues 'local copy
Private mvarFQUD As adiBinValues 'local copy
Private mvarCheck As adiBinValues 'local copy
Private mvarWCLK As adiBinValues 'local copy
Private mvarStrobe As adiBinValues 'local copy
Private mvarCLKValue As Double 'local copy
Private mvarPowerDownDUT As Boolean 'local copy
Private mvarEnabled As Boolean 'local copy
Private mvarD0 As adiBinValues 'local copy
Private mvarD1 As adiBinValues 'local copy
Private mvarD2 As adiBinValues 'local copy
Private mvarD3 As adiBinValues 'local copy
Private mvarD4 As adiBinValues 'local copy
Private mvarD5 As adiBinValues 'local copy
Private mvarD6 As adiBinValues 'local copy
Private mvarD7_SDAT As adiBinValues 'local copy
Private mvarComMode As evbdComMode 'local copy
Private mvarSerailMode As Boolean 'local copy
Private mvarWRB_SCLK As adiBinValues 'local copy
Private mvarPS0 As adiBinValues 'local copy
Private mvarPS1 As adiBinValues 'local copy
Private mvarRDB As adiBinValues 'local copy

'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent ResetOccured[(arg1, arg2, ... , argn)]
Public Event ResetOccured()

'Delcare the LPTIO class
Private PPIO As clsLPTIO
Private sOutputBuffer As String
'local variable(s) to hold property value(s)
Private mvarAutoFQUD As Boolean 'local copy
'To fire this event, use RaiseEvent with the following syntax:
'RaiseEvent OutputBufferChanged[(arg1, arg2, ... , argn)]
Public Event OutputBufferChanged(ByVal Data As String)


Public Property Let RDB(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.RDB = Form1
    If mvarEnabled Then
        mvarRDB = vData
    End If
End Property


Public Property Get RDB() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.RDB
    RDB = mvarRDB
End Property
'Sets the profile
Public Sub SetProfile(ByVal Profile As Integer)
    If mvarEnabled Then
        mvarRDB = vData
    End If
End Sub

Public Property Let PS1(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS1 = Form1
    If mvarEnabled Then
        mvarPS1 = vData
    End If
End Property


Public Property Get PS1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS1
    PS1 = mvarPS1
End Property

Public Property Let PS0(ByVal vData As adiBinValues)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.PS0 = Form1
    If mvarEnabled Then
        mvarPS0 = vData
    End If
End Property


Public Property Get PS0() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PS0
    PS0 = mvarPS0
End Property


Public Property Let WRB_SCLK(ByVal vData As adiBinValues)
Attribute WRB_SCLK.VB_Description = "Write Bar and SCLK signal lines on the Eval Board."
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.WRB_SCLK = Form1
    If mvarEnabled Then
        mvarWRB_SCLK = vData
    End If
End Property


Public Property Get WRB_SCLK() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WRB_SCLK
    WRB_SCLK = mvarWRB_SCLK
End Property

Public Property Let AutoFQUD(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.AutoFQUD = 5
    If mvarEnabled Then
        mvarAutoFQUD = vData
    End If
End Property

Public Property Get AutoFQUD() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.AutoFQUD
    AutoFQUD = mvarAutoFQUD
End Property

'Sends data to the AD9858 through its serial interface
Public Sub SerialLoad(ByVal Data As String)
    Dim cntr As Integer
    Dim DataLen As Integer
    
    'Send 40 bits
    For cntr = 40 To 1 Step -1
        'Set the data on the serial data pin
        D7_SDAT = CLng(Mid(Data, cntr, 1))
        
        'Clock the bit into the AD9850
        WCLK = abvLow
        WCLK = abvHigh
    Next cntr
    
    'Record the new buffer value
    sOutputBuffer = Data
    'Fire the OutputBufferChanged Event
    RaiseEvent OutputBufferChanged(sOutputBuffer)
    
    'If auto frequency update is enabled then go ahead and do it.
    If mvarAutoFQUD Then
        'Do a frequency update to load the data
        FQUD = abvLow
        FQUD = abvHigh
    End If

End Sub
'AD9858 Register Word Definitions
'     Word 0     Word 1     Word 2     Word 3     Word 4
'MSB 00000000   00000000   00000000   00000000   00000000 LSB
'Sends data to the AD9850 through its parallel interface
Private Sub ParallelLoad(ByVal Data As String)
    Dim sW(0 To 4) As String
    Dim bitcnt As Integer
    Dim wcnt As Integer
    Dim BitVal As Integer
    Dim NumOfWords As Integer
    Dim BitCnt2 As Integer
    
    'Get the length of the data to be sent
    NumOfWords = Len(Data)
    NumOfWords = NumOfWords / 8
    
    'Properly build the output buffer
    Select Case NumOfWords
        Case 1:
            sOutputBuffer = Data & Right(sOutputBuffer, 32)
        Case 2:
            sOutputBuffer = Data & Right(sOutputBuffer, 24)
        Case 3:
            sOutputBuffer = Data & Right(sOutputBuffer, 16)
        Case 4:
            sOutputBuffer = Data & Right(sOutputBuffer, 8)
        Case 5:
            sOutputBuffer = Data
    End Select
    
    'Fire the OutputBufferChanged Event
    RaiseEvent OutputBufferChanged(sOutputBuffer)
    
    'Make sure that the address counter is reset
    FQUD = abvLow
    FQUD = abvHigh
    
    'Parallel load all bytes in the order of W0, W1, W2, W3, W4
    For wcnt = NumOfWords To 1 Step -1
        'Get 8 bits to send
        sW(wcnt - 1) = Left(Data, 8)
        'Trim off the bits that are about to be sent
        Data = Right(Data, Len(Data) - 8)
        
        'Convert the binary string to a integer value
        For bitcnt = 1 To 8
            'Get the bit value for the current bit
            BitVal = CInt(Mid(sW(wcnt - 1), 8 - (bitcnt - 1), 1))
            'Set up the word to be sent
            PPIO.SetBitVal ppDataRegister, bitcnt - 1, BitVal
            'Set the properties value so that it will be correct
            Select Case bitcnt - 1
                Case 0:
                    mvarD0 = BitVal
                Case 1:
                    mvarD1 = BitVal
                Case 2:
                    mvarD2 = BitVal
                Case 3:
                    mvarD3 = BitVal
                Case 4:
                    mvarD4 = BitVal
                Case 5:
                    mvarD5 = BitVal
                Case 6:
                    mvarD6 = BitVal
                Case 7:
                    mvarD7 = BitVal
            End Select
        Next bitcnt
        
        'Send the word
        PPIO.WritePort ppDataRegister
        
        'Latch the data through the buffer
        LatchData
        
        'Write the data to the AD9850
        WCLK = abvLow
        WCLK = abvHigh
        
        'Record the new buffer value
'        sOutputBuffer = Data
    Next wcnt
    
    'If auto frequency update is enabled then go ahead and do it.
    If mvarAutoFQUD Then
        'Do a frequency update to load the data
        FQUD = abvLow
        FQUD = abvHigh
    End If
End Sub

Public Property Let ComMode(ByVal vData As evbdComMode)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.ComMode = 5
    Dim OutData As String
    If mvarEnabled = True Then
        'If the user is changing the mode, set the appropriate mode
        If vData = Parallel And mvarComMode = Serial Then
            'Put the part into parallel mode
            'Toggle the S/P to a 1
        ElseIf vData = Serial And mvarComMode = Parallel Then
            'Set the spmode pin
        End If
        mvarComMode = vData
    End If
End Property


Public Property Get ComMode() As evbdComMode
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ComMode
    ComMode = mvarComMode
End Property

'Latch the data
Public Sub LatchData()
    'Strobe the Strobe Line
    Strobe = abvLow
    Strobe = abvHigh
End Sub

Public Property Let Enabled(ByVal vData As Boolean)
Attribute Enabled.VB_Description = "Enables or disables the class from performing I/O."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Enabled = 5
    mvarEnabled = vData
End Property

Public Property Get Enabled() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Enabled
    Enabled = mvarEnabled
End Property

Public Property Let PowerDownDUT(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.PowerDownDUT = 5
    
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        mvarPowerDownDUT = vData
    End If
End Property

Public Property Get PowerDownDUT() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.PowerDownDUT
    PowerDownDUT = mvarPowerDownDUT
End Property

Public Sub SetPhaseDelay(ByVal PhaseDly As Double)
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
    End If
End Sub

Public Property Let CLKValue(ByVal vData As Double)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.CLKValue = 5
    
    mvarCLKValue = vData
    
End Property

Public Property Get CLKValue() As Double
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.CLKValue
    CLKValue = mvarCLKValue
End Property

Public Sub SetDUTOutputFreq(ByVal OutputFreq As Double)
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
    End If
End Sub

Public Sub ResetDUT()
    Dim Start As Single
    
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        'Reset the DUT
        Reset = abvHigh
                
        'Do a short delay until the
        Start = Timer()
        
        'Show the Hourglass mouse pointer
        Screen.MousePointer = 11
        Do While Timer < Start + 0.05
        Loop
        
        'Show the Defualt mouse pointer
        Screen.MousePointer = 0
        
        Reset = abvLow
    End If
End Sub

Public Property Let D7_SDAT(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D7_SDAT = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarD7_SDAT = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit7, mvarD7_SDAT
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D7_SDAT() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D7_SDAT
    D7_SDAT = mvarD7_SDAT
End Property

Public Property Let D6(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D6 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarD6 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit6, mvarD6
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D6() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D6
    D6 = mvarD6
End Property

Public Property Let D5(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D5 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarD5 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit5, mvarD5
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D5() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D5
    D5 = mvarD5
End Property

Public Property Let D4(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D4 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
   
        mvarD4 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit4, mvarD4
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D4() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D4
    D4 = mvarD4
End Property

Public Property Let D3(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D3 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarD3 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit3, mvarD3
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D3() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D3
    D3 = mvarD3
End Property

Public Property Let D2(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D2 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarD2 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit2, mvarD2
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D2() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D2
    D2 = mvarD2
End Property

Public Property Let D1(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D1 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        
        mvarD1 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppBit1, mvarD1
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D1() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D1
    D1 = mvarD1
End Property

Public Property Let D0(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.D0 = 5
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        mvarD0 = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppDataRegister, ppbit0, mvarD0
        
        'Write the new value to the parallel port
        PPIO.WritePort ppDataRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get D0() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.D0
    D0 = mvarD0
End Property

Public Property Let Strobe(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Strobe = 5
    Dim InvertedData As Long
    
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarStrobe = vData
        
        'Invert the data before sending it to the LPT Port because this bit is
        'inverted at the parallel port output
        If mvarStrobe = abvHigh Then
            InvertedData = abvLow
        Else
            InvertedData = abvHigh
        End If
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppControlRegister, ppBit3, InvertedData
        
        'Write the new value to the parallel port
        PPIO.WritePort ppControlRegister
    
'        'Latch the data through the buffer
'        LatchData
    End If
End Property

Public Property Get Strobe() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Strobe
    Strobe = mvarStrobe
End Property

Public Property Let WCLK(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.WCLK = 5
    Dim InvertedData As Long
    
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        mvarWCLK = vData
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppControlRegister, ppBit2, mvarWCLK
        
        'Write the new value to the parallel port
        PPIO.WritePort ppControlRegister
    
        'Latch the data through the buffer
        LatchData
    End If
End Property

Public Property Get WCLK() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.WCLK
    WCLK = mvarWCLK
End Property
'Do not allow the Check signal to be set it is Read Only
Public Property Let Check(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Check = 5
'    mvarCheck = vData
End Property

Public Property Get Check() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Check
    'Do the io opperation if enabled
    If Enabled = True Then
        'Latch the data through
        LatchData
                
        'Read the appropriate bit
        PPIO.ReadPort ppStatusRegister
        Check = PPIO.GetBitVal(ppaStatusRegister, ppBit3)
    End If
End Property

Public Property Let FQUD(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FQUD = 5
    Dim Inverted As adiBinValues
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        mvarFQUD = vData
    
        'Invert the data before outputing it to the lpt port
        If mvarFQUD = abvHigh Then
            Inverted = abvLow
        Else
            Inverted = abvHigh
        End If
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppControlRegister, ppBit1, Inverted
        
        'Write the new value to the parallel port
        PPIO.WritePort ppControlRegister
    
        'Latch the data through the buffer
        LatchData
    End If
    
End Property

Public Property Get FQUD() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FQUD
    FQUD = mvarFQUD
End Property

Public Property Let Reset(ByVal vData As adiBinValues)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Reset = 5
    Dim Inverted As adiBinValues
    Dim RSetOccrd As Boolean
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    
        'Detect a true reset
        If mvarReset = abvHigh And vData = abvLow Then
            RSetOccrd = True
        End If
        'Store the new value for future reference
        mvarReset = vData
        
        'Invert the data before outputing it to the lpt port
        If mvarReset = abvHigh Then
            Inverted = abvLow
        Else
            Inverted = abvHigh
        End If
        
        'Set the appropriate bit in the Parallel Port Driver
        PPIO.SetBitVal ppControlRegister, ppbit0, Inverted
        
        'Write the new value to the parallel port
        PPIO.WritePort ppControlRegister
    
        'Latch the data through the buffer
        LatchData
        
        'If the line is being set to a high then reset the Class also
        If vData = abvHigh Then
            mvarComMode = Parallel
            mvarFQUD = abvHigh
            mvarStrobe = abvLow
            mvarWCLK = abvLow
            sOutputBuffer = "0000000000000000000000000000000000000000"
            RaiseEvent OutputBufferChanged("0000000000000000000000000000000000000000")
        End If
        
        'Trigger the ResetOccured event it one occured
        If RSetOccrd Then
            RaiseEvent ResetOccured
        End If
    End If

End Property

Public Property Get Reset() As adiBinValues
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Reset
    Reset = mvarReset
End Property

Public Sub WriteData2Dut(ByVal Data As Variant)
    'Do the io opperation if enabled
    If mvarEnabled = True Then
        'Send the properly using the proper mode
        If ComMode = Parallel Then
            ParallelLoad Data
        Else
            SerialLoad Data
        End If
    End If
End Sub

Private Sub Class_Initialize()
    
    'Setup the lptio class
    Set PPIO = New clsLPTIO
    
    'Initialize the output buffer
    sOutputBuffer = "0000000000000000000000000000000000000000"
    
    'Initialize all properties
    mvarEnabled = True
    mvarComMode = Parallel
    FQUD = abvLow
    WCLK = abvLow
    Strobe = abvLow
    mvarAutoFQUD = True
End Sub

Private Sub Class_Terminate()
    
    'Setup the lptio class
    Set PPIO = Nothing
    
End Sub
'AD9850 Register Word Definitions
'     Word 0     Word 1     Word 2     Word 3     Word 4
'MSB 00000000   00000000   00000000   00000000   00000000 LSB
Private Sub GetWordValues(W() As Integer, Optional ByVal sBinData)
    Dim cntr As Integer
    Dim BitCntr As Integer
    Dim sBinWord As Integer
    
    ReDim W(0 To 4)
    
    If IsMissing(sBinData) Then
        'If sBinData variable is missing then use the OutputBuffer
        sBinData = sOutputBuffer
    End If
    
    For cntr = 4 To 0 Step -1
        'Get a word from the data
        sBinWord = Right(sBinData, 8)
        'Trim off the word from the origional data
        sBinData = Left(sBinData, Len(sBinData) - 8)
            
        For BitCntr = 0 To 7
            If Right(sBinWord, 1) = "1" Then
                'Add on the bit value to the word value
                W(cntr) = W(cntr) + 2 ^ BitCntr
            End If
            'Trim off the bit
            sBinWord = Left(sBinWord, Len(sBinWord) - 1)
        Next BitCntr
    Next cntr
End Sub


Public Property Get SerialMode() As evbdSerMode
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    End If
End Property

Public Property Let SerialMode(ByVal vNewValue As evbdSerMode)
    'Do the io opperation if enabled
    If mvarEnabled = True Then
    End If
End Property
