VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmDebug 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Debug Window"
   ClientHeight    =   6375
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   10335
   Icon            =   "frmDebug.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   6375
   ScaleWidth      =   10335
   Begin VB.Frame fraTogglePS0 
      Caption         =   "Toggle PS0 at set interval"
      Height          =   855
      Left            =   2040
      TabIndex        =   87
      Top             =   5400
      Width           =   2535
      Begin VB.CheckBox chkTglPS0Dut2 
         Caption         =   "DUT2"
         Height          =   195
         Left            =   1440
         TabIndex        =   93
         Top             =   240
         Width           =   855
      End
      Begin VB.CheckBox chkTglPS0Dut1 
         Caption         =   "DUT1"
         Height          =   195
         Left            =   240
         TabIndex        =   92
         Top             =   240
         Value           =   1  'Checked
         Width           =   855
      End
      Begin VB.TextBox txtPS0ToggleRate 
         Height          =   285
         Left            =   720
         MaxLength       =   5
         TabIndex        =   89
         Text            =   "1"
         Top             =   480
         Width           =   615
      End
      Begin VB.CheckBox chkStartPS0Toggle 
         Caption         =   "START"
         Height          =   255
         Left            =   1680
         Style           =   1  'Graphical
         TabIndex        =   88
         Top             =   480
         Width           =   735
      End
      Begin VB.Timer tmrTogglePS0 
         Enabled         =   0   'False
         Interval        =   1
         Left            =   2040
         Top             =   120
      End
      Begin VB.Label lblms 
         Caption         =   "ms"
         Height          =   255
         Left            =   1365
         TabIndex        =   91
         Top             =   510
         Width           =   255
      End
      Begin VB.Label lblToggleRate 
         Caption         =   "Interval:"
         Height          =   255
         Left            =   120
         TabIndex        =   90
         Top             =   480
         Width           =   615
      End
   End
   Begin VB.Frame fraHispeedSCLK 
      Caption         =   "Fast SCLK 1"
      Height          =   615
      Left            =   6600
      TabIndex        =   84
      ToolTipText     =   "Uses the DriverX's PortOPQueue Method"
      Top             =   5640
      Width           =   1095
      Begin VB.CommandButton cmdHiSpeedStart 
         Caption         =   "START"
         Height          =   375
         Left            =   120
         TabIndex        =   85
         ToolTipText     =   "Generates a the highest speed sclk possible with current board and software architecture."
         Top             =   240
         Width           =   855
      End
      Begin VB.CheckBox chkHiSpeedStop 
         Caption         =   "STOP"
         Height          =   375
         Left            =   120
         Style           =   1  'Graphical
         TabIndex        =   86
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.CheckBox chkFakeOutRegA 
      Caption         =   "Address Register 0x0A as Register 0x09 on Readback"
      Height          =   255
      Left            =   4680
      TabIndex        =   83
      Top             =   5400
      Value           =   1  'Checked
      Width           =   4215
   End
   Begin VB.Frame fraExerciseIO 
      Caption         =   "Exercise I/O"
      Height          =   855
      Left            =   9000
      TabIndex        =   80
      Top             =   5400
      Width           =   1215
      Begin VB.CommandButton cmdExcerciseIOLines 
         Caption         =   "START"
         Height          =   495
         Left            =   120
         TabIndex        =   81
         Top             =   240
         Width           =   975
      End
      Begin VB.CheckBox chkStopExercise 
         Caption         =   "STOP"
         Height          =   495
         Left            =   120
         Style           =   1  'Graphical
         TabIndex        =   82
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.TextBox txtPID 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   2880
      Locked          =   -1  'True
      TabIndex        =   79
      Top             =   7800
      Width           =   855
   End
   Begin VB.CheckBox chkAdminAccess 
      Alignment       =   1  'Right Justify
      Caption         =   "Has Admin Access"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   77
      Top             =   7800
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.Frame fraRAMTest 
      Caption         =   "RAM Test"
      Height          =   855
      Left            =   120
      TabIndex        =   75
      Top             =   5400
      Visible         =   0   'False
      Width           =   1815
      Begin VB.CommandButton cmdRAMTest 
         Caption         =   " RAM BIST"
         Height          =   375
         Left            =   120
         TabIndex        =   76
         Top             =   360
         Width           =   1575
      End
   End
   Begin VB.Frame fraRAMSegLoad 
      Caption         =   "RAM Segment Load "
      Height          =   855
      Left            =   120
      TabIndex        =   69
      Top             =   6840
      Visible         =   0   'False
      Width           =   4575
      Begin VB.ComboBox cmbRAMSegment 
         Height          =   315
         ItemData        =   "frmDebug.frx":0442
         Left            =   1320
         List            =   "frmDebug.frx":0452
         Style           =   2  'Dropdown List
         TabIndex        =   71
         Top             =   360
         Width           =   975
      End
      Begin VB.CommandButton cmdLoadRAMSeg 
         Caption         =   "Load RAM Segment File"
         Height          =   495
         Left            =   2400
         TabIndex        =   70
         Top             =   240
         Width           =   2055
      End
      Begin VB.Label lblRAMSegment 
         Caption         =   "RAM Segment:"
         Height          =   255
         Left            =   120
         TabIndex        =   72
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.CommandButton cmdTestRAMBuff 
      Caption         =   "TestRAMBuff"
      Height          =   495
      Left            =   6360
      TabIndex        =   74
      Top             =   7080
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Write - Read"
      Height          =   495
      Left            =   4800
      TabIndex        =   73
      Top             =   7080
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.Timer tmrButtonFlash 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   7200
      Top             =   5400
   End
   Begin MSComDlg.CommonDialog cdgRAMFile 
      Left            =   8520
      Top             =   6480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame fraOtherStuff 
      Height          =   2295
      Left            =   8520
      TabIndex        =   59
      Top             =   3000
      Width           =   1695
      Begin VB.CommandButton cmdReadRAM 
         Caption         =   "Load RAM File..."
         Height          =   375
         Left            =   90
         TabIndex        =   62
         Top             =   600
         Width           =   1515
      End
      Begin VB.CommandButton cmdDumpMemory 
         Caption         =   "Dump RAM..."
         Height          =   375
         Left            =   90
         TabIndex        =   61
         Top             =   1020
         Width           =   1515
      End
      Begin VB.CommandButton cmdReadSDO 
         Caption         =   "Read SDO"
         Height          =   375
         Left            =   90
         TabIndex        =   60
         Top             =   180
         Width           =   1155
      End
      Begin VB.Label lblIOInfoDut2 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00E0E0E0&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "DUT2"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   225
         Left            =   840
         TabIndex        =   68
         Top             =   1500
         Width           =   765
      End
      Begin VB.Label lblIOInfoDut1 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00E0E0E0&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "DUT1"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   225
         Left            =   90
         TabIndex        =   67
         Top             =   1500
         Width           =   765
      End
      Begin VB.Label lblIOFormatDUT2 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H0080FF80&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "MSB First"
         ForeColor       =   &H80000008&
         Height          =   255
         Left            =   840
         TabIndex        =   66
         Top             =   1950
         Width           =   765
      End
      Begin VB.Label lblIOModeDUT2 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H0080FF80&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "2 - Wire"
         ForeColor       =   &H80000008&
         Height          =   255
         Left            =   840
         TabIndex        =   65
         Top             =   1710
         Width           =   765
      End
      Begin VB.Label lblIOFormatDUT1 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H0080FF80&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "MSB First"
         ForeColor       =   &H80000008&
         Height          =   255
         Left            =   90
         TabIndex        =   64
         Top             =   1950
         Width           =   765
      End
      Begin VB.Label lblIOModeDUT1 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H0080FF80&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "2 - Wire"
         ForeColor       =   &H80000008&
         Height          =   255
         Left            =   90
         TabIndex        =   63
         Top             =   1710
         Width           =   765
      End
      Begin VB.Image imgSDOIndicator 
         Height          =   180
         Left            =   1350
         Picture         =   "frmDebug.frx":0462
         Top             =   270
         Width           =   180
      End
   End
   Begin VB.Frame fraOtherSignals 
      Caption         =   "Other Signals"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   6240
      TabIndex        =   54
      Top             =   2040
      Width           =   3975
      Begin VB.Image imgCtrlLines 
         Height          =   240
         Index           =   3
         Left            =   3000
         Picture         =   "frmDebug.frx":0544
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "Clock F"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   135
         Index           =   10
         Left            =   3000
         TabIndex        =   58
         Top             =   540
         Width           =   855
      End
      Begin VB.Image imgCtrlLines 
         Height          =   240
         Index           =   2
         Left            =   2040
         Picture         =   "frmDebug.frx":0D46
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "Clock A"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   135
         Index           =   8
         Left            =   2040
         TabIndex        =   57
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "Clock D"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   135
         Index           =   9
         Left            =   1080
         TabIndex        =   56
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblOtherSignals 
         Alignment       =   2  'Center
         Caption         =   "RB_Enable"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   135
         Index           =   0
         Left            =   120
         TabIndex        =   55
         Top             =   540
         Width           =   855
      End
      Begin VB.Image imgCtrlLines 
         Height          =   240
         Index           =   1
         Left            =   1080
         Picture         =   "frmDebug.frx":1548
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgCtrlLines 
         Height          =   240
         Index           =   0
         Left            =   120
         Picture         =   "frmDebug.frx":1D4A
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
   End
   Begin VB.Frame fraSendData 
      Caption         =   "Send Data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   120
      TabIndex        =   39
      Top             =   3000
      Width           =   8295
      Begin VB.ComboBox cmbSendDUT 
         Height          =   315
         ItemData        =   "frmDebug.frx":254C
         Left            =   120
         List            =   "frmDebug.frx":2559
         Style           =   2  'Dropdown List
         TabIndex        =   50
         Top             =   600
         Width           =   855
      End
      Begin VB.TextBox txtSData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Index           =   4
         Left            =   2160
         MaxLength       =   8
         TabIndex        =   48
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.CommandButton cmdSendData 
         Caption         =   "Write"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   13.5
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   735
         Left            =   7080
         TabIndex        =   45
         Top             =   240
         Width           =   1095
      End
      Begin VB.TextBox txtSData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Index           =   3
         Left            =   3120
         MaxLength       =   8
         TabIndex        =   44
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtSData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Index           =   2
         Left            =   4080
         MaxLength       =   8
         TabIndex        =   43
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtSData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Index           =   1
         Left            =   5040
         MaxLength       =   8
         TabIndex        =   42
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtSData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Index           =   0
         Left            =   6000
         MaxLength       =   8
         TabIndex        =   41
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.ComboBox cmbSendAddr 
         Height          =   315
         ItemData        =   "frmDebug.frx":256A
         Left            =   1080
         List            =   "frmDebug.frx":2598
         Style           =   2  'Dropdown List
         TabIndex        =   40
         Top             =   600
         Width           =   975
      End
      Begin VB.Label lblSendDUT 
         Caption         =   "DUT:"
         Height          =   255
         Left            =   120
         TabIndex        =   51
         Top             =   360
         Width           =   735
      End
      Begin VB.Label lblData 
         Caption         =   "MSB < - - - - - - - - - - - - - - DATA TO WRITE - - - - - - - - - - - - - > LSB"
         Height          =   255
         Left            =   2160
         TabIndex        =   47
         Top             =   360
         Width           =   4815
      End
      Begin VB.Label lblAddress 
         Caption         =   "Address:"
         Height          =   255
         Left            =   1080
         TabIndex        =   46
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame fraReadData 
      Caption         =   "Read Data"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   120
      TabIndex        =   30
      Top             =   4200
      Width           =   8295
      Begin VB.ComboBox cmbReadDUT 
         Height          =   315
         ItemData        =   "frmDebug.frx":2604
         Left            =   120
         List            =   "frmDebug.frx":260E
         Style           =   2  'Dropdown List
         TabIndex        =   52
         Top             =   600
         Width           =   855
      End
      Begin VB.TextBox txtRData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   315
         Index           =   4
         Left            =   2160
         Locked          =   -1  'True
         MaxLength       =   8
         TabIndex        =   49
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.CommandButton cmdRead 
         Caption         =   "Read"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   13.5
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   735
         Left            =   7080
         TabIndex        =   36
         Top             =   240
         Width           =   1095
      End
      Begin VB.TextBox txtRData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   315
         Index           =   3
         Left            =   3120
         Locked          =   -1  'True
         MaxLength       =   8
         TabIndex        =   35
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtRData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   315
         Index           =   2
         Left            =   4080
         Locked          =   -1  'True
         MaxLength       =   8
         TabIndex        =   34
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtRData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   315
         Index           =   1
         Left            =   5040
         Locked          =   -1  'True
         MaxLength       =   8
         TabIndex        =   33
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.TextBox txtRData 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   315
         Index           =   0
         Left            =   6000
         Locked          =   -1  'True
         MaxLength       =   8
         TabIndex        =   32
         Text            =   "00000000"
         Top             =   600
         Width           =   975
      End
      Begin VB.ComboBox cmbReadAddress 
         Height          =   315
         ItemData        =   "frmDebug.frx":2618
         Left            =   1080
         List            =   "frmDebug.frx":2646
         Style           =   2  'Dropdown List
         TabIndex        =   31
         Top             =   600
         Width           =   975
      End
      Begin VB.Label lblReadDUT 
         Caption         =   "DUT:"
         Height          =   255
         Left            =   120
         TabIndex        =   53
         Top             =   360
         Width           =   735
      End
      Begin VB.Label lblReadData 
         Caption         =   "MSB < - - - - - - - - - - - - - - - - DATA READ - - - - - - - - - - - - - - - > LSB"
         Height          =   255
         Left            =   2160
         TabIndex        =   38
         Top             =   360
         Width           =   4815
      End
      Begin VB.Label lblReadAddr 
         Caption         =   "Address:"
         Height          =   255
         Left            =   1080
         TabIndex        =   37
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame lblDUT1Signals 
      Caption         =   "Buff 1 Signals"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   10095
      Begin VB.CommandButton cmdSetVals 
         Caption         =   "APPLY"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Index           =   0
         Left            =   8880
         Style           =   1  'Graphical
         TabIndex        =   27
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "FUD DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   7
         Left            =   7920
         TabIndex        =   8
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "FUD DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   6
         Left            =   6720
         TabIndex        =   7
         Top             =   540
         Width           =   975
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "OSK DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   5
         Left            =   5640
         TabIndex        =   6
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "OSK DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   4
         Left            =   4560
         TabIndex        =   5
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "PS1 DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   3
         Left            =   3480
         TabIndex        =   4
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "PS0 DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   2
         Left            =   2280
         TabIndex        =   3
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "PS1 DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   1
         Left            =   1200
         TabIndex        =   2
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff1Signals 
         Alignment       =   2  'Center
         Caption         =   "PS0 DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   540
         Width           =   855
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   7
         Left            =   7890
         Picture         =   "frmDebug.frx":26B2
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   6
         Left            =   6780
         Picture         =   "frmDebug.frx":2EB4
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   5
         Left            =   5670
         Picture         =   "frmDebug.frx":36B6
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   4
         Left            =   4560
         Picture         =   "frmDebug.frx":3EB8
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   3
         Left            =   3450
         Picture         =   "frmDebug.frx":46BA
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   2
         Left            =   2340
         Picture         =   "frmDebug.frx":4EBC
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   1
         Left            =   1230
         Picture         =   "frmDebug.frx":56BE
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff1Btn 
         Height          =   240
         Index           =   0
         Left            =   120
         Picture         =   "frmDebug.frx":5EC0
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
   End
   Begin VB.Frame fraBuff2Signals 
      Caption         =   "Buff 2 Signals"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   120
      TabIndex        =   9
      Top             =   1080
      Width           =   10095
      Begin VB.CommandButton cmdSetVals 
         Caption         =   "APPLY"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Index           =   1
         Left            =   8880
         Style           =   1  'Graphical
         TabIndex        =   28
         Top             =   240
         Width           =   1095
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   0
         Left            =   120
         Picture         =   "frmDebug.frx":66C2
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   1
         Left            =   1230
         Picture         =   "frmDebug.frx":6EC4
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   2
         Left            =   2340
         Picture         =   "frmDebug.frx":76C6
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   3
         Left            =   3450
         Picture         =   "frmDebug.frx":7EC8
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   4
         Left            =   4560
         Picture         =   "frmDebug.frx":86CA
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   5
         Left            =   5670
         Picture         =   "frmDebug.frx":8ECC
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   6
         Left            =   6780
         Picture         =   "frmDebug.frx":96CE
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff2Btn 
         Height          =   240
         Index           =   7
         Left            =   7890
         Picture         =   "frmDebug.frx":9ED0
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "I/O Sync DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   17
         Top             =   540
         Width           =   975
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "I/O Sync DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   1
         Left            =   1080
         TabIndex        =   16
         Top             =   540
         Width           =   1095
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "Pwr Dwn DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   2
         Left            =   2280
         TabIndex        =   15
         Top             =   540
         Width           =   975
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "Pwr Dwn DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   3
         Left            =   3360
         TabIndex        =   14
         Top             =   540
         Width           =   1095
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "ClkMdSel DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   4
         Left            =   4440
         TabIndex        =   13
         Top             =   540
         Width           =   1095
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "ClkMdSel DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   5
         Left            =   5520
         TabIndex        =   12
         Top             =   540
         Width           =   1095
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "Reset DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   6
         Left            =   6720
         TabIndex        =   11
         Top             =   540
         Width           =   975
      End
      Begin VB.Label lblBuff2Signals 
         Alignment       =   2  'Center
         Caption         =   "Reset DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   7
         Left            =   7800
         TabIndex        =   10
         Top             =   540
         Width           =   975
      End
   End
   Begin VB.Frame fraBuff3Signals 
      Caption         =   "Buff 3 Signals"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   120
      TabIndex        =   18
      Top             =   2040
      Width           =   6015
      Begin VB.CommandButton cmdSetVals 
         Caption         =   "APPLY"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Index           =   2
         Left            =   5040
         Style           =   1  'Graphical
         TabIndex        =   29
         Top             =   240
         Width           =   855
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   " "
         Height          =   255
         Index           =   7
         Left            =   7920
         TabIndex        =   26
         Top             =   1020
         Width           =   735
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   " "
         Height          =   255
         Index           =   6
         Left            =   6840
         TabIndex        =   25
         Top             =   1020
         Width           =   735
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   " "
         Height          =   255
         Index           =   5
         Left            =   7560
         TabIndex        =   24
         Top             =   900
         Width           =   855
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "Ref_Clk"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   4
         Left            =   4080
         TabIndex        =   23
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "CSB_DUT2"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   3
         Left            =   3120
         TabIndex        =   22
         Top             =   540
         Width           =   735
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "CSB_DUT1"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   2
         Left            =   2040
         TabIndex        =   21
         Top             =   540
         Width           =   975
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "SCLK"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   1
         Left            =   1080
         TabIndex        =   20
         Top             =   540
         Width           =   855
      End
      Begin VB.Label lblBuff3Signals 
         Alignment       =   2  'Center
         Caption         =   "SDIO"
         BeginProperty Font 
            Name            =   "Small Fonts"
            Size            =   6.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   19
         Top             =   540
         Width           =   855
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   615
         Index           =   7
         Left            =   7680
         Picture         =   "frmDebug.frx":A6D2
         Tag             =   "0"
         Top             =   480
         Visible         =   0   'False
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   615
         Index           =   6
         Left            =   7680
         Picture         =   "frmDebug.frx":B4B0
         Tag             =   "0"
         Top             =   240
         Visible         =   0   'False
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   615
         Index           =   5
         Left            =   7680
         Picture         =   "frmDebug.frx":C28E
         Tag             =   "0"
         Top             =   600
         Visible         =   0   'False
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   240
         Index           =   4
         Left            =   4080
         Picture         =   "frmDebug.frx":D06C
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   240
         Index           =   3
         Left            =   3090
         Picture         =   "frmDebug.frx":D86E
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   240
         Index           =   2
         Left            =   2100
         Picture         =   "frmDebug.frx":E070
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   240
         Index           =   1
         Left            =   1110
         Picture         =   "frmDebug.frx":E872
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
      Begin VB.Image imgBuff3Btn 
         Height          =   240
         Index           =   0
         Left            =   120
         Picture         =   "frmDebug.frx":F074
         Tag             =   "0"
         Top             =   240
         Width           =   870
      End
   End
   Begin VB.Label lblProcessID 
      Caption         =   "Process ID:"
      Height          =   255
      Left            =   2040
      TabIndex        =   78
      Top             =   7800
      Width           =   855
   End
   Begin VB.Image imgGLED 
      Height          =   180
      Index           =   1
      Left            =   7800
      Picture         =   "frmDebug.frx":F876
      Top             =   6480
      Visible         =   0   'False
      Width           =   180
   End
   Begin VB.Image imgGLED 
      Height          =   180
      Index           =   0
      Left            =   7560
      Picture         =   "frmDebug.frx":F958
      Top             =   6480
      Visible         =   0   'False
      Width           =   180
   End
   Begin VB.Image imgButton 
      Height          =   240
      Index           =   1
      Left            =   1080
      Picture         =   "frmDebug.frx":FA3A
      Top             =   6480
      Visible         =   0   'False
      Width           =   870
   End
   Begin VB.Image imgButton 
      Height          =   240
      Index           =   0
      Left            =   120
      Picture         =   "frmDebug.frx":1023C
      Top             =   6480
      Visible         =   0   'False
      Width           =   870
   End
End
Attribute VB_Name = "frmDebug"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private sRegSize(0 To 12) As Integer
Private BuffNeedsLoading(0 To 2) As Boolean
Const TwoWireColor = &H80FF80
Const ThreeWireColor = &H80C0FF
Private PS0Cntr As Integer
Private Togglerate As Long




Private Sub chkStopHiSpeed_Click()

End Sub

Private Sub chkStartPS0Toggle_Click()
    If chkStartPS0Toggle.value = 1 Then
        PS0Cntr = 0 'Reset the counter
        tmrTogglePS0.Enabled = True
    Else
        tmrTogglePS0.Enabled = False
    End If
End Sub

Private Sub chkTglPS0Dut1_Click()
    If chkTglPS0Dut1.value = 1 Or chkTglPS0Dut2.value = 1 Then
        chkStartPS0Toggle.Enabled = True
    Else
        chkStartPS0Toggle.Enabled = False
    End If
End Sub

Private Sub chkTglPS0Dut2_Click()
    If chkTglPS0Dut1.value = 1 Or chkTglPS0Dut2.value = 1 Then
        chkStartPS0Toggle.Enabled = True
    Else
        chkStartPS0Toggle.Enabled = False
    End If
End Sub

Private Sub cmbReadAddress_Click()
    Dim RegBytes As Integer
    Dim cntr As Integer
    'Get the number of bytes to be sent
    RegBytes = sRegSize(cmbReadAddress.ListIndex)
    
    'Enable only the textboxes that can be sent
    For cntr = 0 To 4
        If cntr <= RegBytes - 1 Then
            txtRData(cntr).Enabled = True
        Else
            txtRData(cntr).Enabled = False
        End If
    Next cntr
End Sub

Private Sub cmbSendAddr_Click()
    Dim RegBytes As Integer
    Dim cntr As Integer
    Dim RegValLen As Integer
    Dim CurrentRegVal As String
    Dim dummuystr As String
    
    'Get the number of bytes to be sent
    RegBytes = sRegSize(cmbSendAddr.ListIndex)
    
    'Enable only the textboxes that can be sent
    For cntr = 0 To 4
        If cntr <= RegBytes - 1 Then
            txtSData(cntr).Enabled = True
'            txtSData(cntr).Text = "00000000"
        Else
            txtSData(cntr).Enabled = False
'            txtSData(cntr).Text = "00000000"
        End If
    Next cntr
        
'    'Get the current value of the register
'    CurrentRegVal = EvalBd.sGetRegVal(cmbSendDUT.ListIndex - 1, cmbSendAddr.ItemData(cmbSendAddr.ListIndex))
'    'Get the length of the current value of the register
'    RegValLen = Len(CurrentRegVal) / 8
'
'    dummystr = CurrentRegVal
'
'    For cntr = RegValLen To 0 Step -1
'        'Get the left 8 bits
'        txtSData(cntr).Text = Left(dummystr, 8)
'        'Trim off the left 8 bits
'        dummystr = Right(dummystr, cntr * 8)
'    Next cntr
    
End Sub

Private Sub cmdDumpMemory_Click()
    Dim DUTNum As String
    Dim FileDescription As String
    
    'Setup an error handler
    On Error GoTo ErrorHandler
    
    'Setup the common dialog for opening files
    cdgRAMFile.flags = cdlOFNFileMustExist + cdlOFNHideReadOnly + cdlOFNLongNames + cdlOFNNoChangeDir
    cdgRAMFile.DialogTitle = "Choose a file to DUMP the RAM to."
    cdgRAMFile.CancelError = True
    cdgRAMFile.filter = "RAM Files (*.ram)|*.ram|Text (*.txt)|*.txt|All Files (*.*)|*.*"
    cdgRAMFile.FilterIndex = 0
    cdgRAMFile.InitDir = App.path

    'Show the open dialog
    cdgRAMFile.ShowSave
    
    'If the file exists then ask do they want to overwrite.
    If FileExists(cdgRAMFile.filename) Then
        If MsgBox("The file you have specified already exists." & vbCrLf & "Would you like to overwrite the file?", vbApplicationModal + vbYesNo + vbQuestion, "Overwrite File?") = vbYes Then
            'Overwrite the specified file.
            DUTNum = InputBox("Enter the DUT number you would like to DUMP the RAM info from." & vbCrLf & "Ex: 1 for DUT1" & vbCrLf & "    2 for DUT2" & vbCrLf & "    0 for Both DUTs", "Select A DUT", "1")
            If DUTNum = "1" Or DUTNum = "2" Then
                FileDescription = InputBox("Enter a short discription for the RAM dump file.", "Enter File Desciption")
                EvalBd.RAMDumpFile CInt(DUTNum), cdgRAMFile.filename, FileDescription
            End If
        End If
    Else
        'Write the specified file.
        DUTNum = InputBox("Enter the DUT number you would like to DUMP the RAM info from." & vbCrLf & "Ex: 1 for DUT1" & vbCrLf & "    2 for DUT2" & vbCrLf & "    0 for Both DUTs", "Select A DUT", "1")
        If DUTNum = "1" Or DUTNum = "2" Then
            FileDescription = InputBox("Enter a short discription for the RAM dump file.", "Enter File Desciption")
            EvalBd.RAMDumpFile CInt(DUTNum), cdgRAMFile.filename, FileDescription
        End If
    End If
    'Exit the subroutine before the errorhandler
    Exit Sub

'Define an error handler
ErrorHandler:
    'Check for the cancel button hit error
    If Err.Number = cdlCancel Then
        'Exit the subroutine if the cancel button was hit
        Exit Sub
    End If
End Sub

Private Sub cmdExcerciseIOLines_Click()
    cmdExcerciseIOLines.Visible = False
    Do
        'Write all lines to 1's
        EvalBd.PPIO.WritePort ppDataRegister, 255
        'Latch in the data
        EvalBd.PPIO.WritePort ppControlRegister, 11
        EvalBd.PPIO.WritePort ppControlRegister, 0
        'Write them to all 0's
        EvalBd.PPIO.WritePort ppDataRegister, 0
        'Latch in the data
        EvalBd.PPIO.WritePort ppControlRegister, 11
        EvalBd.PPIO.WritePort ppControlRegister, 0
        
        'Allow the usr to stop
        DoEvents
    Loop Until chkStopExercise.value = 1
    chkStopExercise.value = 0
    cmdExcerciseIOLines.Visible = True
End Sub

Private Sub cmdHiSpeedStart_Click()
    Dim cntr As Integer
    Dim NumBytes As Integer

    Dim OutputByte As Integer 'The Byte to output
    Dim OpQue As Long 'The OP Que for the Driver X Driver
            
    Const dbSCLK = 2
    Const dbSDIO = 1
    Const dbSCLKLo = 0
    Const dbCLOCKF = 8
    Const dbCLOCKFLo = 0
        
    With frmLPTSelect.dxcParallelPort
        OpQue = .AllocateOpQueue(0, 36, 0)
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLK 'Take SCLK High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
        .QueueOutp OpQue, ppaDataRegister, dbSCLKLo 'Take SCLK Low
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKF 'Latch SCLK through the Buffer by taking CLOCKF High
        .QueueOutp OpQue, ppaControlRegister, dbCLOCKFLo 'Take CLOCKFLow
    End With

    cmdHiSpeedStart.Visible = False
    Do
        frmLPTSelect.dxcParallelPort.Execute OpQue
        
        'Allow the usr to stop
        DoEvents
    Loop Until chkHiSpeedStop.value = 1
    'Delete the Op Queue
    frmLPTSelect.dxcParallelPort.DeleteOpQueue OpQue
    chkHiSpeedStop.value = 0
    cmdHiSpeedStart.Visible = True
End Sub


Private Sub cmdLoadRAMSeg_Click()
    Dim DUTNum1 As Integer
    Dim FilePath As String
    
    'Let the user browse for the file
    FilePath = frmFileBrowse.ShowDialog("Select a RAM Configuation File to Load.", "LOAD", DUTNum1, "")
    
    'If the user didn't just cancel out and they picked a valid file
    If FilePath <> "" Then
        EvalBd.RAMLoadFileSeg DUTNum1, cmbRAMSegment.ListIndex, FilePath
    End If
    
    'Exit the subroutine before the errorhandler
    Exit Sub
End Sub

Private Sub cmdRAMTest_Click()
    Dim RSCW0_FullRAM As String
    Dim RSCW0_ADDR0 As String
    Dim CFR1_RAMEnable As String
    Dim TestReg As String
    Dim RAMSigRegDUT1 As String
    Dim RAMSigRegDUT2 As String
    
    Const TestValue = "10000001000010011110000111111000"
    
    RSCW0_FullRAM = "0000000000000000111111110000001100000000"
    RSCW0_ADDR0 = "0000000000000000000000000000000000000000"
    CFR1_RAMEnable = "10000000000000000000000000000000"
    TestReg = "00000000000000000001010000000000"
    
    'Set the profile to profile 0
    EvalBd.SetActiveProfile 0, 1
    
    'Hourglass
    Screen.MousePointer = 11
    
    'Clear the RSCW1
    EvalBd.SerialLoad 0, &H8, RSCW0_ADDR0
    'Check to see if DUT1 is installed and test if it is
    If EvalBd.DutsInstalled And 1 Then
        'Reset DUT1
        EvalBd.ResetDUT (1)
        
        'Set up the RAM Segment Control Register
        EvalBd.SerialLoad 1, &H7, RSCW0_FullRAM
        'Enable the RAM
        EvalBd.SerialLoad 1, &H0, CFR1_RAMEnable
        'Write the RAMBist Test Register Value
        EvalBd.SerialLoad 1, &HC, TestReg
        
        'Wait a while
        Delay 2
        
        'Configure to readback from address 0
        EvalBd.SerialLoad 1, &H7, RSCW0_ADDR0
        
        'Read the signature register
        RAMSigRegDUT1 = EvalBd.SerialRead(1, &HB)
        
        If RAMSigRegDUT1 = TestValue Then
            MsgBox "DUT1's RAM Passed!", vbInformation, "DUT1 RAM Test Finshed"
        Else
            MsgBox "DUT1's RAM Failed!", vbInformation, "DUT1 RAM Test Finshed"
        End If
    End If
    
    'Check to see if DUT2 is installed and test if it is
    If EvalBd.DutsInstalled And 2 Then
        'Reset DUT2
        EvalBd.ResetDUT (2)
        'Set up the RAM Segment Control Register
        EvalBd.SerialLoad 2, &H7, RSCW0_FullRAM
        'Enable the RAM
        EvalBd.SerialLoad 2, &H0, CFR1_RAMEnable
        'Write the RAMBist Test Register Value
        EvalBd.SerialLoad 2, &HC, TestReg
        
        'Wait a while
        Delay 2
        
        'Configure to readback from address 0
        EvalBd.SerialLoad 2, &H7, RSCW0_ADDR0
        
        'Read the signature register
        RAMSigRegDUT1 = EvalBd.SerialRead(2, &HB)
        
        If RAMSigRegDUT1 = TestValue Then
            MsgBox "DUT2's RAM Passed!", vbInformation, "DUT2 RAM Test Finshed"
        Else
            MsgBox "DUT2's RAM Failed!", vbInformation, "DUT2 RAM Test Finshed"
        End If
    End If
    
    'Reset both duts
    EvalBd.ResetDUT (0)
    
    'Default
    Screen.MousePointer = 0
    
    'Update the display
    Me.UpdateDisplay
    If IsLoaded("frmRAMConfig") Then
        frmRAMConfig.RefreshControls
    End If
End Sub

Private Sub cmdRead_Click()
    Dim strData As String
    Dim cntr As Integer
    Dim cntr1 As Integer
    Dim DataLen As Integer
    
    'Request data from the AD9858 from the Address specified by cmbReceiveAddress
    strData = EvalBd.SerialRead(cmbReadDUT.ListIndex + 1, cmbReadAddress.ItemData(cmbReadAddress.ListIndex), chkFakeOutRegA.value)
    
    'Get the length of the string data returned from the AD9858
    DataLen = Len(strData)
    
    'Loop through the data displaying it in the textboxes
    For cntr = 0 To DataLen / 8 - 1
        cntr1 = Len(strData) - 8
        'Fill the textboxes from the binary string returned by the serialread() method
        txtRData(cntr).Text = Right(strData, 8)
        'Update the register map to display  the data
        'frmRegisterMap.sSetRegVal cmbReadAddress.ListIndex + cntr, txtRData(cntr).Text
        
        'Trim off the data that was just displayed
        strData = Left(strData, cntr1)
    Next cntr
    
    'Update the user interface
    UpdateDisplay
    
    'Refresh the status
    'RefreshStatus
End Sub

Private Sub cmdReadRAM_Click()
    Dim DUTNum1 As Integer
    Dim FilePath As String
    
    'Let the user browse for the file
    FilePath = frmFileBrowse.ShowDialog("Select a RAM Configuation File to Load.", "LOAD", DUTNum1, "")
    
    'If the user didn't just cancel out and they picked a valid file
    If FilePath <> "" Then
        EvalBd.RAMLoadFile DUTNum1, FilePath
    End If
    
    'Exit the subroutine before the errorhandler
    Exit Sub
End Sub

Private Sub cmdReadSDO_Click()
    'Read the value from the port
    imgSDOIndicator.Picture = imgGLED(EvalBd.SDO).Picture
End Sub

Private Sub cmdSendData_Click()
    Dim strData As String
    Dim cntr As Integer
    
    'Build the binary data string from the textboxes
    For cntr = 0 To sRegSize(cmbSendAddr.ListIndex) - 1
        If txtSData(cntr).Enabled = True Then
            strData = txtSData(cntr).Text & strData
        End If
    Next cntr
    
    'Update the register map to display the data
'    frmRegisterMap.sSetSerialRegVal cmbSendAddr.ListIndex, strData
    
    'Send the data to the AD9859 using the address specified by cmbSendAddr
    EvalBd.SerialLoad cmbSendDUT.ListIndex, cmbSendAddr.ItemData(cmbSendAddr.ListIndex), strData
    
    'Update the user interface
    UpdateDisplay
    
    'Refresh the status
    'RefreshStatus
    'Refresh the IO Controls interface
    'frmIOInterface.RefreshControls
End Sub

Private Sub cmdSetVals_Click(Index As Integer)
    'Transfer the values to the evalboard
'    EvalBd.WriteEvbBuffVal Index
    Select Case Index
        Case 0
            'Strobe the Clock_D line
            'EvalBd.Strobe_Clock_D
            EvalBd.WriteEvbBuffVal evb59Buff1
            
        Case 1
            'Strobe the Clock_A line
'            EvalBd.Strobe_Clock_A
            EvalBd.WriteEvbBuffVal evb59Buff2
            
        Case 2
            'Strobe the Clock_F line
'            EvalBd.Strobe_Clock_F
            EvalBd.WriteEvbBuffVal evb59Buff3
            
    End Select
    'Make sure that the backcolor gets reset to normal
    cmdSetVals(Index).BackColor = NormalColor
    BuffNeedsLoading(Index) = False
    
End Sub

Private Sub cmdTestRAMBuff_Click()
    frmEditRam.Show
End Sub

Private Sub Command1_Click()
    cmdSendData_Click
    cmdRead_Click
End Sub

Private Sub Command2_Click()
    Dim cntr As Integer
        
    'Try and detect a DUT on each LPT port connected to the
    For cntr = 0 To frmLPTSelect.LPTGetPortCount() - 1
        'Select the LPT port to test
        frmLPTSelect.LPTSelectPort cntr
        'Sync up the PC and Eval Board
        EvalBd.InitEvalBoard
        'Try to Detect the DUTs
        NumOfDUTsDetected = EvalBd.DetectDUTs
        EvBdDetected = EvalBd.DetectEvalBoard
        If NumOfDUTsDetected Or EvBdDetected Then
            EvalBdDetected = True
            Exit For
        End If
    Next cntr
    
        
End Sub

Private Sub Form_Activate()
    'Enable the button flasher only if the form has been made active
    tmrButtonFlash.Enabled = True
End Sub

Private Sub Form_Load()
    Dim cntr As Integer
    Dim StopReg As Integer
    
    'Initialize the serial mode register size lookup table,
    'sizes are in number of bytes
    sRegSize(0) = 4
    sRegSize(1) = 3
    sRegSize(2) = 2
    sRegSize(3) = 1
    sRegSize(4) = 4
    sRegSize(5) = 2
    sRegSize(6) = 4
    sRegSize(7) = 5
    sRegSize(8) = 5
    sRegSize(9) = 5
    sRegSize(10) = 5
    sRegSize(11) = 4
    sRegSize(12) = 4
    
    SetMode
'    Initialize the dropdown listboxes
    cmbSendAddr.Clear
    cmbReadAddress.Clear

    If AdiMode Then
        StopReg = 12
    Else
        StopReg = 11
    End If

    For cntr = 0 To StopReg
        cmbSendAddr.AddItem "0" & Hex(cntr) & " Hex"
        cmbReadAddress.AddItem "0" & Hex(cntr) & " Hex"

        cmbSendAddr.ItemData(cntr) = cntr
        cmbReadAddress.ItemData(cntr) = cntr
    Next cntr
    
    cmbRAMSegment.ListIndex = 0
    cmbSendAddr.ListIndex = 0
    cmbReadAddress.ListIndex = 0
    cmbSendDUT.ListIndex = 1
    cmbReadDUT.ListIndex = 0
    
    'Update the User Interface for the Debug window
    UpdateDisplay
    
    Me.Move 0, 0

'    If AdiMode Then
'        SetAdiMode
'    Else
'        Me.Height = 5790
'    End If

End Sub

Private Sub imgBuff1Btn_DblClick(Index As Integer)
    'Run the mouse down routine
    imgBuff1Btn_MouseDown Index, 1, 0, 0, 0
End Sub

Private Sub imgBuff1Btn_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        'Set the needs loading flag
        BuffNeedsLoading(0) = True
        If imgBuff1Btn(Index).Tag = "0" Then
            imgBuff1Btn(Index).Picture = imgButton(1).Picture
            imgBuff1Btn(Index).Tag = "1"
            'Set the bit high
            'EvalBd.SetBitVal evb59Buff1, Index, abvHigh
            Select Case Index
                Case 0:
                    EvalBd.PS0_DUT1 = abvHigh
                Case 1:
                    EvalBd.PS1_DUT1 = abvHigh
                Case 2:
                    EvalBd.PS0_DUT2 = abvHigh
                Case 3:
                    EvalBd.PS1_DUT2 = abvHigh
                Case 4:
                    EvalBd.OSK_DUT1 = abvHigh
                Case 5:
                    EvalBd.OSK_DUT2 = abvHigh
                Case 6:
                    EvalBd.FUD_DUT1 = abvHigh
                Case 7:
                    EvalBd.FUD_DUT2 = abvHigh
            End Select
        Else
            imgBuff1Btn(Index).Picture = imgButton(0).Picture
            imgBuff1Btn(Index).Tag = "0"
            'Set the bit high
            'EvalBd.SetBitVal evb59Buff1, Index, abvLow
            Select Case Index
                Case 0:
                    EvalBd.PS0_DUT1 = abvLow
                Case 1:
                    EvalBd.PS1_DUT1 = abvLow
                Case 2:
                    EvalBd.PS0_DUT2 = abvLow
                Case 3:
                    EvalBd.PS1_DUT2 = abvLow
                Case 4:
                    EvalBd.OSK_DUT1 = abvLow
                Case 5:
                    EvalBd.OSK_DUT2 = abvLow
                Case 6:
                    EvalBd.FUD_DUT1 = abvLow
                Case 7:
                    EvalBd.FUD_DUT2 = abvLow
            End Select
        End If
    End If
End Sub

Private Sub imgBuff2Btn_DblClick(Index As Integer)
    imgBuff2Btn_MouseDown Index, 1, 0, 0, 0
End Sub

Private Sub imgBuff2Btn_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        'Set the needs loading flag
        BuffNeedsLoading(1) = True
        If imgBuff2Btn(Index).Tag = "0" Then
            imgBuff2Btn(Index).Picture = imgButton(1).Picture
            imgBuff2Btn(Index).Tag = "1"
            'Set the bit high
            'EvalBd.SetBitVal evb59Buff2, Index, abvHigh
            Select Case Index
                Case 0:
                    EvalBd.IOSync_DUT1 = abvHigh
                Case 1:
                    EvalBd.IOSync_DUT2 = abvHigh
                Case 2:
                    EvalBd.PwrDwnCtl_Dut1 = abvHigh
                Case 3:
                    EvalBd.PwrDwnCtl_Dut2 = abvHigh
                Case 4:
                    EvalBd.ClkMdSel_DUT1 = abvHigh
                Case 5:
                    EvalBd.ClkMdSel_DUT2 = abvHigh
                Case 6:
                    EvalBd.Reset_DUT1 = abvHigh
                Case 7:
                    EvalBd.Reset_DUT2 = abvHigh
            End Select
        Else
            imgBuff2Btn(Index).Picture = imgButton(0).Picture
            imgBuff2Btn(Index).Tag = "0"
            'Set the bit low
            'EvalBd.SetBitVal evb59Buff2, Index, abvLow
            Select Case Index
                Case 0:
                    EvalBd.IOSync_DUT1 = abvLow
                Case 1:
                    EvalBd.IOSync_DUT2 = abvLow
                Case 2:
                    EvalBd.PwrDwnCtl_Dut1 = abvLow
                Case 3:
                    EvalBd.PwrDwnCtl_Dut2 = abvLow
                Case 4:
                    EvalBd.ClkMdSel_DUT1 = abvLow
                Case 5:
                    EvalBd.ClkMdSel_DUT2 = abvLow
                Case 6:
                    EvalBd.Reset_DUT1 = abvLow
                Case 7:
                    EvalBd.Reset_DUT2 = abvLow
            End Select
        End If
    End If

End Sub

Private Sub imgBuff3Btn_DblClick(Index As Integer)
    imgBuff3Btn_MouseDown Index, 1, 0, 0, 0
End Sub

Private Sub imgBuff3Btn_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        'Set the needs loading flag
        BuffNeedsLoading(2) = True
        If imgBuff3Btn(Index).Tag = "0" Then
            imgBuff3Btn(Index).Picture = imgButton(1).Picture
            imgBuff3Btn(Index).Tag = "1"
            'Set the bit high
            'EvalBd.SetBitVal evb59Buff3, Index, abvHigh
            Select Case Index
                Case 0:
                    EvalBd.SDIO = abvHigh
                Case 1:
                    EvalBd.SCLK = abvHigh
                Case 2:
                    EvalBd.CSB_DUT1 = abvHigh
                Case 3:
                    EvalBd.CSB_DUT2 = abvHigh
                Case 4:
                    EvalBd.REF_CLK = abvHigh
                Case 5:
                    EvalBd.SetBitVal evb59Buff3, Index, abvHigh
                Case 6:
                    EvalBd.SetBitVal evb59Buff3, Index, abvHigh
                Case 7:
                    EvalBd.SetBitVal evb59Buff3, Index, abvHigh
            End Select
        Else
            imgBuff3Btn(Index).Picture = imgButton(0).Picture
            imgBuff3Btn(Index).Tag = "0"
            'Set the bit low
            'EvalBd.SetBitVal evb59Buff3, Index, abvLow
            Select Case Index
                Case 0:
                    EvalBd.SDIO = abvLow
                Case 1:
                    EvalBd.SCLK = abvLow
                Case 2:
                    EvalBd.CSB_DUT1 = abvLow
                Case 3:
                    EvalBd.CSB_DUT2 = abvLow
                Case 4:
                    EvalBd.REF_CLK = abvLow
                Case 5:
                    EvalBd.SetBitVal evb59Buff3, Index, abvLow
                Case 6:
                    EvalBd.SetBitVal evb59Buff3, Index, abvLow
                Case 7:
                    EvalBd.SetBitVal evb59Buff3, Index, abvLow
            End Select
        End If
    End If
End Sub

Private Sub imgCtrlLines_DblClick(Index As Integer)
    imgCtrlLines_MouseDown Index, 1, 0, 0, 0
End Sub

Private Sub imgCtrlLines_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Then
        If imgCtrlLines(Index).Tag = "0" Then
            imgCtrlLines(Index).Picture = imgButton(1).Picture
            imgCtrlLines(Index).Tag = "1"
            'Set the bit high
            Select Case Index
                Case 0:
                    EvalBd.RB_Enable = abvHigh
                Case 1:
                    EvalBd.Clock_D = abvHigh
                Case 2:
                    EvalBd.Clock_A = abvHigh
                Case 3:
                    EvalBd.Clock_F = abvHigh
                Case 4:
                    'EvalBd.REF_CLK = abvHigh
                Case 5:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvHigh
                Case 6:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvHigh
                Case 7:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvHigh
            End Select
        Else
            imgCtrlLines(Index).Picture = imgButton(0).Picture
            imgCtrlLines(Index).Tag = "0"
            'Set the bit low
            'EvalBd.SetBitVal evb59Buff3, Index, abvLow
            Select Case Index
                Case 0:
                    EvalBd.RB_Enable = abvLow
                Case 1:
                    EvalBd.Clock_D = abvLow
                Case 2:
                    EvalBd.Clock_A = abvLow
                Case 3:
                    EvalBd.Clock_F = abvLow
                Case 4:
                    'EvalBd.REF_CLK = abvLow
                Case 5:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvLow
                Case 6:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvLow
                Case 7:
                    'EvalBd.SetBitVal evb59Buff3, Index, abvLow
            End Select
        End If
    End If
End Sub

Private Sub imgDutTabs_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If X <= imgDutTabs.Width / 2 Then
        'Select Dut1 Tab
        imgDutTabs.Picture = imgDut1Sel.Picture
    Else
        'Select Dut2 Tab
        imgDutTabs.Picture = imgDut2Sel.Picture
    End If
    imgDutTabs.Refresh
End Sub

Private Sub tmrButtonFlash_Timer()
    Static fcntr1 As Integer
    Static fcntr2 As Integer
    Static fcntr3 As Integer
    
    'Flash the buttons if the values need loading
    If BuffNeedsLoading(0) = True Then
        If fcntr1 <> 3 Then
            cmdSetVals(0).BackColor = NormalColor
        Else
            cmdSetVals(0).BackColor = FlashOnColor
        End If
                
        'Increment or reset the counter
        If fcntr1 >= 3 Then
            fcntr1 = 0
        Else
            fcntr1 = fcntr1 + 1
        End If
    End If
    If BuffNeedsLoading(1) = True Then
        If fcntr2 <> 3 Then
            cmdSetVals(1).BackColor = NormalColor
        Else
            cmdSetVals(1).BackColor = FlashOnColor
        End If
                
        'Increment or reset the counter
        If fcntr2 >= 3 Then
            fcntr2 = 0
        Else
            fcntr2 = fcntr2 + 1
        End If
    End If
    If BuffNeedsLoading(2) = True Then
        If fcntr3 <> 3 Then
            cmdSetVals(2).BackColor = NormalColor
        Else
            cmdSetVals(2).BackColor = FlashOnColor
        End If
                
        'Increment or reset the counter
        If fcntr3 >= 3 Then
            fcntr3 = 0
        Else
            fcntr3 = fcntr3 + 1
        End If
    End If
End Sub

Private Sub tmrTogglePS0_Timer()
'    Dim togglerate As Integer
    
    'Make sure the user has entered a valid toggle rate
'    If txtPS0ToggleRate.Text = "" Or Not IsNumeric(txtPS0ToggleRate.Text) Then
'        togglerate = 1
'    Else
'        If CInt(txtPS0ToggleRate.Text) < 10 Then
'            txtPS0ToggleRate.Text = 10
'        End If
'        togglerate = CInt(txtPS0ToggleRate.Text) / 10
'    End If
    
    'Increment the counter
'    PS0Cntr = PS0Cntr + 1
'    'Reset the counter
'    If PS0Cntr >= togglerate Then
'        PS0Cntr = 0
'    End If
    
    'Do the toggling when counter is 0
'    If PS0Cntr = 1 Then
        If chkTglPS0Dut1.value = 1 Then
            If EvalBd.PS0_DUT1 = abvLow Then
                EvalBd.PS0_DUT1 = abvHigh
            Else
                EvalBd.PS0_DUT1 = abvLow
            End If
        End If
        If chkTglPS0Dut2.value = 1 Then
            If EvalBd.PS0_DUT2 = abvLow Then
                EvalBd.PS0_DUT2 = abvHigh
            Else
                EvalBd.PS0_DUT2 = abvLow
            End If
        End If
        EvalBd.WriteEvbBuffVal evb59Buff1
        Me.UpdateDisplay
'    End If
    
End Sub

Private Sub txtPS0ToggleRate_KeyPress(KeyAscii As Integer)
    Dim cncl As Boolean
    'Filter out unwanted keys
    KeyAscii = NumericIntKeysFilter(KeyAscii)
    
    If KeyAscii = 13 Then
        KeyAscii = 0
        txtPS0ToggleRate_Validate cncl
        
    End If
End Sub

Private Sub txtPS0ToggleRate_Validate(Cancel As Boolean)
    'Make sure the user has entered a valid toggle rate
    If txtPS0ToggleRate.Text = "" Or Not IsNumeric(txtPS0ToggleRate.Text) Then
        txtPS0ToggleRate.Text = 1
    Else
        If CLng(txtPS0ToggleRate.Text) < 1 Or CLng(txtPS0ToggleRate.Text) > 65535 Then
            txtPS0ToggleRate.Text = 1
        End If
        'Set the toggle rate
        tmrTogglePS0.Interval = CLng(txtPS0ToggleRate.Text)
    End If
End Sub

Private Sub txtSData_GotFocus(Index As Integer)
    'Select all text in the textbox
    With txtSData(Index)
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

Private Sub txtSData_KeyPress(Index As Integer, KeyAscii As Integer)
    'Filter out all keys except the binary keys
    KeyAscii = BinKeysFilter(KeyAscii)
End Sub

Private Sub txtSData_Validate(Index As Integer, Cancel As Boolean)
    'Set remaining empty spaces to "0"
    txtSData(Index).Text = String(8 - Len(txtSData(Index).Text), "0") & txtSData(Index).Text
End Sub
'Updates the display of the debug window
Public Sub UpdateDisplay()
    Dim cntr As Integer
        
    'Update the values of the eval board signal lines
    imgBuff1Btn(0).Picture = imgButton(EvalBd.PS0_DUT1).Picture
    imgBuff1Btn(0).Tag = CStr(EvalBd.PS0_DUT1)
    imgBuff1Btn(1).Picture = imgButton(EvalBd.PS1_DUT1).Picture
    imgBuff1Btn(1).Tag = CStr(EvalBd.PS1_DUT1)
    imgBuff1Btn(2).Picture = imgButton(EvalBd.PS0_DUT2).Picture
    imgBuff1Btn(2).Tag = CStr(EvalBd.PS0_DUT2)
    imgBuff1Btn(3).Picture = imgButton(EvalBd.PS1_DUT2).Picture
    imgBuff1Btn(3).Tag = CStr(EvalBd.PS1_DUT2)
    imgBuff1Btn(4).Picture = imgButton(EvalBd.OSK_DUT1).Picture
    imgBuff1Btn(4).Tag = CStr(EvalBd.OSK_DUT1)
    imgBuff1Btn(5).Picture = imgButton(EvalBd.OSK_DUT2).Picture
    imgBuff1Btn(5).Tag = CStr(EvalBd.OSK_DUT2)
    imgBuff1Btn(6).Picture = imgButton(EvalBd.FUD_DUT1).Picture
    imgBuff1Btn(6).Tag = CStr(EvalBd.FUD_DUT1)
    imgBuff1Btn(7).Picture = imgButton(EvalBd.FUD_DUT2).Picture
    imgBuff1Btn(7).Tag = CStr(EvalBd.FUD_DUT2)
    For cntr = 0 To 7
        imgBuff1Btn(cntr).Refresh
    Next cntr

    imgBuff2Btn(0).Picture = imgButton(EvalBd.IOSync_DUT1).Picture
    imgBuff2Btn(0).Tag = CStr(EvalBd.IOSync_DUT1)
    imgBuff2Btn(1).Picture = imgButton(EvalBd.IOSync_DUT2).Picture
    imgBuff2Btn(1).Tag = CStr(EvalBd.IOSync_DUT2)
    imgBuff2Btn(2).Picture = imgButton(EvalBd.PwrDwnCtl_Dut1).Picture
    imgBuff2Btn(2).Tag = CStr(EvalBd.PwrDwnCtl_Dut1)
    imgBuff2Btn(3).Picture = imgButton(EvalBd.PwrDwnCtl_Dut2).Picture
    imgBuff2Btn(3).Tag = CStr(EvalBd.PwrDwnCtl_Dut2)
    imgBuff2Btn(4).Picture = imgButton(EvalBd.ClkMdSel_DUT1).Picture
    imgBuff2Btn(4).Tag = CStr(EvalBd.ClkMdSel_DUT1)
    imgBuff2Btn(5).Picture = imgButton(EvalBd.ClkMdSel_DUT2).Picture
    imgBuff2Btn(5).Tag = CStr(EvalBd.ClkMdSel_DUT2)
    imgBuff2Btn(6).Picture = imgButton(EvalBd.Reset_DUT1).Picture
    imgBuff2Btn(6).Tag = CStr(EvalBd.Reset_DUT1)
    imgBuff2Btn(7).Picture = imgButton(EvalBd.Reset_DUT2).Picture
    imgBuff2Btn(7).Tag = CStr(EvalBd.Reset_DUT2)
    For cntr = 0 To 7
        imgBuff2Btn(cntr).Refresh
    Next cntr
    
    imgBuff3Btn(0).Picture = imgButton(EvalBd.SDIO).Picture
    imgBuff3Btn(0).Tag = CStr(EvalBd.SDIO)
    imgBuff3Btn(1).Picture = imgButton(EvalBd.SCLK).Picture
    imgBuff3Btn(1).Tag = CStr(EvalBd.SCLK)
    imgBuff3Btn(2).Picture = imgButton(EvalBd.CSB_DUT1).Picture
    imgBuff3Btn(2).Tag = CStr(EvalBd.CSB_DUT1)
    imgBuff3Btn(3).Picture = imgButton(EvalBd.CSB_DUT2).Picture
    imgBuff3Btn(3).Tag = CStr(EvalBd.CSB_DUT2)
    imgBuff3Btn(4).Picture = imgButton(EvalBd.REF_CLK).Picture
    imgBuff3Btn(4).Tag = CStr(EvalBd.REF_CLK)
'    imgBuff3Btn(5).Picture = imgButton(EvalBd.ClkMdSel_DUT2).Picture
'    imgBuff3Btn(6).Picture = imgButton(EvalBd.Reset_DUT1).Picture
'    imgBuff3Btn(7).Picture = imgButton(EvalBd.Reset_DUT2).Picture
    For cntr = 0 To 4
        imgBuff3Btn(cntr).Refresh
    Next cntr
    
    imgCtrlLines(0).Picture = imgButton(EvalBd.RB_Enable).Picture
    imgCtrlLines(0).Tag = EvalBd.RB_Enable
    imgCtrlLines(1).Picture = imgButton(EvalBd.Clock_D).Picture
    imgCtrlLines(1).Tag = EvalBd.Clock_D
    imgCtrlLines(2).Picture = imgButton(EvalBd.Clock_A).Picture
    imgCtrlLines(2).Tag = EvalBd.Clock_A
    imgCtrlLines(3).Picture = imgButton(EvalBd.Clock_F).Picture
    imgCtrlLines(3).Tag = EvalBd.Clock_F
    For cntr = 0 To 3
        imgCtrlLines(cntr).Refresh
    Next cntr
    
    'Update the IOMode and IOFormat Indicators
    If EvalBd.SerialIOModeDUT1 = TwoWire Then
        lblIOModeDUT1.Caption = "2 - Wire"
        lblIOModeDUT1.BackColor = &H80FF80
    Else
        lblIOModeDUT1.Caption = "3 - Wire"
        lblIOModeDUT1.BackColor = &H80C0FF
    End If
    
    If EvalBd.LSBFirstDUT1 = True Then
        lblIOFormatDUT1.Caption = "LSB First"
        lblIOFormatDUT1.BackColor = &H80C0FF
    Else
        lblIOFormatDUT1.Caption = "MSB First"
        lblIOFormatDUT1.BackColor = &H80FF80
    End If
    
    If EvalBd.SerialIOModeDUT2 = TwoWire Then
        lblIOModeDUT2.Caption = "2 - Wire"
        lblIOModeDUT2.BackColor = &H80FF80
    Else
        lblIOModeDUT2.Caption = "3 - Wire"
        lblIOModeDUT2.BackColor = &H80C0FF
    End If
    
    If EvalBd.LSBFirstDUT2 = True Then
        lblIOFormatDUT2.Caption = "LSB First"
        lblIOFormatDUT2.BackColor = &H80C0FF
    Else
        lblIOFormatDUT2.Caption = "MSB First"
        lblIOFormatDUT2.BackColor = &H80FF80
    End If
End Sub

Public Sub SetMode()
    
    'Initialize the dropdown listboxes
    cmbSendAddr.Clear
    cmbReadAddress.Clear
    
    If AdiMode Then
        StopReg = 12
    Else
        StopReg = 11
    End If
    
    For cntr = 0 To 12
        cmbSendAddr.AddItem "0" & Hex(cntr) & " Hex"
        cmbReadAddress.AddItem "0" & Hex(cntr) & " Hex"
        
        cmbSendAddr.ItemData(cntr) = cntr
        cmbReadAddress.ItemData(cntr) = cntr
    Next cntr
    
    cmbRAMSegment.ListIndex = 0
    cmbSendAddr.ListIndex = 0
    cmbReadAddress.ListIndex = 0
    cmbSendDUT.ListIndex = 1
    cmbReadDUT.ListIndex = 0
    
    If AdiMode Then
        Me.Height = 6750
        fraRAMTest.Visible = True
    
        chkAdminAccess.Visible = True
        lblProcessID.Visible = True
        txtPID.Visible = True
    
        If IsWinNT() Then
    '            If HasAdminRights() Then
    '                chkAdminAccess.value = 1
    '            Else
    '                chkAdminAccess.value = 0
    '            End If
        Else
            chkAdminAccess.Enabled = False
        End If
        txtPID.Text = GetPID()
    Else
        Me.Height = 5770
    End If
    
End Sub
